(module splitter mzscheme
  
  (require (lib "class.ss")
           (lib "mred.ss" "mred"))
  
  (provide vertical-splitter% horizontal-splitter%)
  
  (define horizontal-splitter%
    (class vertical-panel%
      (override on-subwindow-event)
      
      (define top-area (make-object object%))
      (define/public (attach-top ob)
        (set! top-area ob)
        (send top-area stretchable-height #f))
      
      (define bottom-area (make-object object%))
      (define/public (attach-bottom ob)
        (set! bottom-area ob)
        (send bottom-area stretchable-height #t))
      
      
      (define dragging? #f)
      
      (define on-subwindow-event
        (lambda (receiver event)
          (if (equal? this receiver)
              (if (or dragging? 
                      (and (> (send event get-y) (send top-area get-height))
                           (< (send event get-y) (- (send bottom-area get-y) 1))))
                  (begin
                    (send this set-cursor 
                          (make-object cursor% 'size-n/s ))
                    (if (send event get-left-down)
                        (begin
                          (set! dragging? #t)
                          (send top-area min-height
                                (max (- (send event get-y) 2) 0)))
                        (set! dragging? #f)
                        ))
                  (send this set-cursor 
                        (make-object cursor% 'arrow)))  
              (send this set-cursor 
                    (make-object cursor% 'arrow)))
          #f))
      
      (super-instantiate ())))
  
  (define vertical-splitter%
    (class horizontal-panel%
      (override on-subwindow-event)
      
      (define left-area (make-object object%))
      (define/public (attach-left ob)
        (set! left-area ob)
        (send left-area stretchable-width #f))
      
      (define right-area (make-object object%))
      (define/public (attach-right ob)
        (set! right-area ob)
        (send right-area stretchable-width #t))
      
      (define dragging? #f)
      
      (define on-subwindow-event
        (lambda (receiver event)
          (if (equal? this receiver)
              (if (or dragging? 
                      (and (> (send event get-x) (send left-area get-width))
                           (< (send event get-x) (- (send right-area get-x) 1))))
                  (begin
                    (send this set-cursor 
                          (make-object cursor% 'size-e/w ))
                    (if (send event get-left-down)
                        (begin
                          (set! dragging? #t)
                          (send left-area min-width
                                (max (- (send event get-x) 2) 0)))
                        (set! dragging? #f)
                        ))
                  (send this set-cursor 
                        (make-object cursor% 'arrow)))  
              (send this set-cursor 
                    (make-object cursor% 'arrow)))
          #f))
      
      (super-instantiate ())))
  
  ) ;== end module ==